------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Completers;
limited with Qt4.Menus;
with Qt4.Points;
with Qt4.Strings;
limited with Qt4.Validators;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Line_Edits is

   type Line_Edit_Echo_Mode is
    (Normal,
     No_Echo,
     Password,
     Password_Echo_On_Edit);
   pragma Convention (C, Line_Edit_Echo_Mode);

   type Q_Line_Edit is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Line_Edit_Access is
     access all Q_Line_Edit'Class;
   for Q_Line_Edit_Access'Storage_Size use 0;

   type Q_Line_Edit_Pointer is tagged;

   procedure Backspace
    (Self : not null access Q_Line_Edit'Class);

   function Create_Standard_Context_Menu
    (Self : not null access Q_Line_Edit'Class)
       return not null access Qt4.Menus.Q_Menu'Class;

   function Completer
    (Self : not null access constant Q_Line_Edit'Class)
       return not null access Qt4.Completers.Q_Completer'Class;

   function Cursor_Position
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Q_Integer;

   function Cursor_Position_At
    (Self : not null access Q_Line_Edit'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Q_Integer;

   procedure Cursor_Backward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean;
     Steps : Qt4.Q_Integer
       :=  1);

   procedure Cursor_Forward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean;
     Steps : Qt4.Q_Integer
       :=  1);

   procedure Cursor_Word_Backward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean);

   procedure Cursor_Word_Forward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean);

   procedure Del
    (Self : not null access Q_Line_Edit'Class);

   procedure Deselect
    (Self : not null access Q_Line_Edit'Class);

   function Display_Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String;

   function Drag_Enabled
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   function Echo_Mode
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Line_Edits.Line_Edit_Echo_Mode;

   procedure Line_End
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean);

   function Has_Acceptable_Input
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   function Has_Frame
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   function Has_Selected_Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   procedure Home
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean);

   function Input_Mask
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String;

   procedure Insert
    (Self : not null access Q_Line_Edit'Class;
     New_Text : Qt4.Strings.Q_String);

   function Is_Modified
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   function Is_Read_Only
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   function Is_Redo_Available
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   function Is_Undo_Available
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean;

   function Max_Length
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Q_Integer;

   function Selected_Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String;

   function Selection_Start
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Q_Integer;

   procedure Set_Completer
    (Self : not null access Q_Line_Edit'Class;
     C : not null access Qt4.Completers.Q_Completer'Class);

   procedure Set_Cursor_Position
    (Self : not null access Q_Line_Edit'Class;
     Pos : Qt4.Q_Integer);

   procedure Set_Drag_Enabled
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean);

   procedure Set_Echo_Mode
    (Self : not null access Q_Line_Edit'Class;
     Mode : Qt4.Line_Edits.Line_Edit_Echo_Mode);

   procedure Set_Frame
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean);

   procedure Set_Input_Mask
    (Self : not null access Q_Line_Edit'Class;
     Input_Mask : Qt4.Strings.Q_String);

   procedure Set_Max_Length
    (Self : not null access Q_Line_Edit'Class;
     Length : Qt4.Q_Integer);

   procedure Set_Modified
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean);

   procedure Set_Read_Only
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean);

   procedure Set_Selection
    (Self : not null access Q_Line_Edit'Class;
     Start : Qt4.Q_Integer;
     Length : Qt4.Q_Integer);

   procedure Set_Validator
    (Self : not null access Q_Line_Edit'Class;
     V : access constant Qt4.Validators.Q_Validator'Class);

   function Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String;

   function Validator
    (Self : not null access constant Q_Line_Edit'Class)
       return not null access Qt4.Validators.Q_Validator'Class;

   procedure Clear
    (Self : not null access Q_Line_Edit'Class);

   procedure Copy
    (Self : not null access constant Q_Line_Edit'Class);

   procedure Cut
    (Self : not null access Q_Line_Edit'Class);

   procedure Paste
    (Self : not null access Q_Line_Edit'Class);

   procedure Redo
    (Self : not null access Q_Line_Edit'Class);

   procedure Select_All
    (Self : not null access Q_Line_Edit'Class);

   procedure Set_Text
    (Self : not null access Q_Line_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Undo
    (Self : not null access Q_Line_Edit'Class);

   procedure Set_Alignment
    (Self : not null access Q_Line_Edit'Class;
     Flag : Qt4.Alignment);

   package Q_Line_Edit_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Line_Edit, Q_Line_Edit_Access);

   type Q_Line_Edit_Pointer is
     new Q_Line_Edit_Pointers.Q_Pointer with null record;

end Qt4.Line_Edits;
